##Chapter 8
Before we can get to integrating the Google Books API into our app, we have to build out the view for adding a new book to our list (do this in books.html).  The factory's ```addBook()``` method will first fetch our book's ISBN by author and title.  To capture the input from the view for this new book, we use an object on the ```vm``` (called ```newBook```) with the ```title``` and ```author``` properties.  This way, we can pass the entire ```newBook``` object to the factory instead of individual properties.  Finally, include an add book button using the ```ng-click``` directive to call ```vm.addBook``` method you created in the controller.

The Google Books API requires a single "q" query string parameter that searches by title first, then by author using the "inauthor:" string.  For example, https://www.googleapis.com/books/v1/volumes?q=flowers+inauthor:keyes will search for any title containing the string "flowers" by an author that matches the name "keyes" such as Flowers For Algernon.

Notice that we need to traverse the JSON response from the Google Books API to get the ISBN (and to also get the real title and author).  For now, since we are only displaying the first book in our list, we use ```books.unshift()``` to put our new book at the beginning of the array.