(function(){
	angular.module('book')
		.factory('bookFactory', bookFactory);

	function bookFactory($http){

		var books = [
			{
				id: 1,
				title: 'Teach Yourself Angular.js for .NET',
				author: 'Dennis Sheppard, Christopher Miller, AJ Liptak'
			},
			{
				id: 2,
				title: 'Harry Potter and the Chamber of Secrets',
				author: 'JK Rowling'
			},
			{
				id: 3,
				title: 'The Goldfinch',
				author: 'Donna Tart'
			}
		];

		function getBooks() {
			return books;
		}

		function addBook(book){
			return getSearchResults(book)
				.then(function(response) {
					var newBook = {
						title: response.data.items[0].volumeInfo.title,
						author: response.data.items[0].volumeInfo.authors[0],
						isbn: response.data.items[0].volumeInfo.industryIdentifiers[0].identifier
					};
					//let's append the new book to the bottom of the list
					books.push(newBook);
					return books;
				}
			);

		}

		function deleteBook() {
			//We will implement this later
		}

		function updateBook() {
			//We will implement this later
		}

		function getSearchResults(book){
			var queryString = book.title.replace(" ", "+") + '+inauthor:' + book.author.replace(" ", "+");

			return $http.get('https://www.googleapis.com/books/v1/volumes?q=' + queryString);
		}


		return {
			books: books,
			addBook: addBook,
			deleteBook: deleteBook,
			updateBook: updateBook
		};

	}
})();
