(function () {
	angular.module('book')
		.controller('bookController', bookController);

	bookController.$inject = ['bookFactory'];

	function bookController(bookFactory) {
		var vm = this;

		vm.title = "Books!";
		vm.newBook = {
			title: '',
			author: ''
		};
		vm.books = [];
		vm.addBook = addBook;
		vm.deleteBook = deleteBook;
		vm.updateBook = updateBook;

		//////////////////////////

		activate();

		function activate(){
			vm.books = bookFactory.books;
		}


		///////////ViewModel Methods

		function addBook(){
			bookFactory.addBook(vm.newBook);
		};

		function deleteBook() {
			bookFactory.deleteBook();
		};

		function updateBook() {
			bookFactory.updateBook();
		};

	}
})();