##Chapter 18
You should install karma and requirejs as development dependencies by using ```npm install karma requirejs --save-dev```.  Next, run ```karma init``` and answer the questions as seen in the chapter.  Finally, install angular-mocks as done in the chapter.

Now, write a test to verify that ```bookController``` is defined and that the title is "Books!".  Start by modifying your karma.conf.js to include angular, other dependencies like angular-mocks and angular-route, and the ```utilities``` module (utilities.js) prior to all other JavaScript files.  Then, as you ```describe()``` your test, use ```inject()``` to inject ```$rootScope``` and ```bookFactory``` and save those as variables so you can reuse them across tests in the same file.  Next, inside your test suite, use ```it()``` to test the controller's definition as done in the chapter.  Finally, use another ```it()``` to test the title.

Next, write a test to verify that ```bookFactory``` is defined, that ```addBook()``` exists, and that ```addBook()``` correctly calls an API to add the book.  Let's refactor a bit and add an ```apiFactory``` that will handle all references to ```$http``` for our app.  This will allow us to test the actual HTTP call to the our API (yet to be written, that's coming in Chapter 22), including its success and failure states, separately from the ```addBook``` function.  Inject this new factory into ```bookFactory``` and modify it to call ```api.Get()``` making sure to pass in the entire query string and parameters. 
 
Modify your tests to use ```api``` instead of ```bookFactory``` and writes tests to verify a successful call (status code 200) and another test to verify a failed call (404)