describe('api', function() {

	var $httpBackend, api, $http;

	// Set up the module
	beforeEach(function() {
		module('book');

		inject(function( _$httpBackend_, _api_, _$http_) {
			$httpBackend = _$httpBackend_;
			api = _api_;
			$http = _$http_;

		});
	});

	afterEach(function() {
		$httpBackend.verifyNoOutstandingExpectation();
		$httpBackend.verifyNoOutstandingRequest();
	});


	describe('api', function() {

		it('Should define methods', function () {
			expect(api.Get).toBeDefined();
			expect(api.Get).toEqual(jasmine.any(Function))
		});

		it('Should return book array', function() {
			var books = [{
				id: 1,
				title: 'Teach Yourself AngularJS for .NET',
				author: 'Dennis Sheppard, Christopher Miller, AJ Liptak'
			},
			{
				id: 2,
				title: 'Harry Potter and the Chamber of Secrets',
				author: 'JK Rowling',
				price: 29.99,
				currency: 'EUR'
			}];

			$httpBackend.expectGET('/books').respond(200, books);
			var result;

			api.Get('/books')
				.success(function(data){
					result = data;
				}).error(function(reason){
					result = reason;
				});

			$httpBackend.flush();

			expect(result).toEqual(books);
		});

		it('Should return status Not Found', function() {
			$httpBackend.expectGET('/invalid').respond(404, 'Not Found');
			var result = '';
			var data = '';
			api.Get('/invalid')
				.success(function(data){
					data = data;
				}).error(function(reason){
					result = reason;
				});

			$httpBackend.flush();
			expect(result).toEqual('Not Found');
		});

	});
});