(function () {
	angular.module('book')
		.controller('bookController', bookController);

	bookController.$inject = ['$scope', 'bookFactory'];

	function bookController($scope, bookFactory) {
		var vm = this;

		vm.title = "Books!";
		vm.newBook = {
			title: '',
			author: ''
		};
		vm.books = [];
		vm.addBook = addBook;
		vm.deleteBook = deleteBook;
		vm.updateBook = updateBook;
		vm.bookSelected = bookSelected;

		//////////////////////////

		activate();

		function activate(){
			vm.books = bookFactory.books;
		}


		///////////ViewModel Methods

		function addBook(){
			bookFactory.addBook(vm.newBook);
		}

		function deleteBook() {
			bookFactory.deleteBook();
		}

		function updateBook() {
			bookFactory.updateBook();
		}

		function bookSelected(book){
			$scope.$emit('bookSelected', book);
		}

	}
})();