(function(){
	angular.module('book')
		.factory('bookFactory', bookFactory);

	bookFactory.$inject = ['api'];

	function bookFactory(api){
		var books = [];
		var bookFactory = {
			books: books,
			addBook: addBook,
			deleteBook: deleteBook,
			updateBook: updateBook
		};

		var myBooks = [
			{
				id: 1,
				title: 'Teach Yourself AngularJS for .NET',
				author: 'Dennis Sheppard, Christopher Miller, AJ Liptak'
			},
			{
				id: 2,
				title: 'Harry Potter and the Chamber of Secrets',
				author: 'JK Rowling',
				price: 29.99,
				currency: 'EUR'
			},
			{
				id: 3,
				title: 'The Goldfinch',
				author: 'Donna Tart'
			},
			{
				id: 4,
				title: 'Aprilhäxan',
				author: 'Majgull Axelsson',
				price: 19.99,
				currency: 'SEK'
			}
		];

		books.push.apply(books, myBooks);


		function addBook(book){
			return getSearchResults(book)
				.then(function(response) {

					var price = (response.data.items[0].saleInfo.listPrice)
						? response.data.items[0].saleInfo.listPrice.amount
						: 0;

					var currency = (response.data.items[0].saleInfo.listPrice)
						? response.data.items[0].saleInfo.listPrice.currencyCode
						: 'USD';

					var newBook = {
						title: response.data.items[0].volumeInfo.title,
						author: response.data.items[0].volumeInfo.authors[0],
						isbn: response.data.items[0].volumeInfo.industryIdentifiers[0].identifier,
						price: price,
						currency: currency
					};
					
					//let's append the new book to the bottom of the list
					bookFactory.books.push(newBook);
					return bookFactory.books;
				}
			);

		}

		function deleteBook() {
			//We will implement this later
		}

		function updateBook() {
			//We will implement this later
		}

		function getSearchResults(book){
			var queryString = book.title.replace(" ", "+") + '+inauthor:' + book.author.replace(" ", "+");

			return api.Get(queryString);
		}


		return bookFactory;

	}
})();
