(function () {
	angular.module('book', [
		'ngRoute',
		'utilities',
		'authentication'
	]).config(router);

	router.$inject = ['$routeProvider'];

	function router($routeProvider){
		$routeProvider.
			when('/books', {
				templateUrl: 'book/books.html',
				controller: 'bookController',
				controllerAs: 'vm'
			}).when('/register', {
				templateUrl: 'authentication/register.html',
				controller: 'registerController',
				controllerAs: 'vm'
			})
			.when('/login', {
				templateUrl: 'authentication/login.html',
				controller: 'loginController',
				controllerAs: 'vm'
			})
			.otherwise({
				redirectTo: '/login'
			});
	}

	angular.module('book')
		.value('appConstants', {
			apiPrefix: 'http://<<your-app-name>>.azurewebsites.net',
			tokenKey: 'BOOKAPPTOKEN'
		});
})();