(function(){
    angular.module('authentication')
        .factory('authenticationFactory', authenticationFactory);

    authenticationFactory.$inject = ['api', 'appConstants', 'LocalStorageManager'];

    function authenticationFactory(api, appConstants, LocalStorageManager){
        return {
            Login: login,
            Register: register
        };

        function login(username, password) {
            var params = {
                username: username,
                password: password,
                grant_type: "password"
            };

            var config = {
                headers: {
                    'Content-Type': 'application/x-www-form-urlencoded'
                },
                transformRequest: function(obj) {
                    var str = [];
                    for (var p in obj)
                        str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
                    return str.join("&");
                }
            };

            return api.Post(appConstants.apiPrefix + '/token', params, config)
              .success(function(response) {
                  LocalStorageManager.Set(appConstants.tokenKey, response);
                  return response;
              })
              .error(function(error) {
                  return error;
              });
        }        
        
        function register(userData){
            var url = appConstants.apiPrefix + '/api/account/register';
            return api.Post(url, userData).success(function(response){

            })
            .error(function(error){
                alert(error);
            });
        }
    }

})();