(function() {

	angular.module('book')
		.factory('api', api);

	api.$inject = ['$http', 'LocalStorageManager', 'appConstants'];

	function api($http, LocalStorageManager, appConstants) {

		return {
			Get: get,
			Post: post,
			Put: put,
			Delete: remove
		};

		////////////////

		function get(url, params) {
			return $http.get(url, {params: params});
		}

		function post(url, data, config) {
			return $http.post(url, data, config);
		}

		function put(url, data) {
			return $http.put(url, data);
		}

		function remove(url) {
			return $http.delete(url);
		}

	}

})();