(function () {
	angular.module('book')
		.controller('bookController', bookController);

	bookController.$inject = ['$scope', 'bookFactory'];

	function bookController($scope, bookFactory) {
		var vm = this;

		vm.title = "Books!";
		vm.newBook = {
			title: '',
			author: ''
		};
		vm.books = [];
		vm.addBook = addBook;
		vm.deleteBook = deleteBook;
		vm.updateBook = updateBook;
		vm.bookSelected = bookSelected;

		//////////////////////////

		activate();

		function activate(){
			getBooks();
		}


		///////////ViewModel Methods

		function addBook(){
			bookFactory.addBook(vm.newBook).then(function(book) {
				vm.books.push(book.data);
			});
		}

		function deleteBook() {
			bookFactory.deleteBook();
		}

		function updateBook() {
			bookFactory.updateBook();
		}

		function bookSelected(book){
			$scope.$emit('bookSelected', book);
		}
		
		///////////Private methods
		function getBooks() {
			bookFactory.getBooks().success(function(books){
					vm.books = books;
				})
				.error(function(error) {
					//handle error here
				});
		}

	}
})();