(function() {

  angular.module('utilities')
    .factory('LocalStorageManager', LocalStorageManager);

  LocalStorageManager.$inject = [];

  function LocalStorageManager() {
    
    return {
      Get: get,
      Set: set,
      Remove: remove,
      DoesExist: doesExist
    }

    function get(key) {
      var storageItem = localStorage.getItem(key);
      if (isJson(storageItem)) {
        return angular.fromJson(storageItem);
      }
      return storageItem;
    }

    function set(key, value) {
      if (typeof value === 'string') {
        localStorage.setItem(key, value);
      } else {
        try {
          var stringVal = angular.toJson(value);
          localStorage.setItem(key, stringVal);
        } catch (error) {
          localStorage.setItem(key, error);
        }
      }
      return get(key);
    }

    function remove(key) {
      localStorage.removeItem(key);
    }

    function doesExist(key) {
      if (get(key)) {
        return true;
      }
      return false;
    }

    //////
    function isJson(str) {
      try {
        JSON.parse(str);
      } catch (e) {
        return false;
      }
      return true;
    }
  }

})();